aboutsummaryrefslogtreecommitdiff
path: root/contrib/bc/tests/script.sh
diff options
context:
space:
mode:
Diffstat (limited to 'contrib/bc/tests/script.sh')
-rwxr-xr-xcontrib/bc/tests/script.sh72
1 files changed, 57 insertions, 15 deletions
diff --git a/contrib/bc/tests/script.sh b/contrib/bc/tests/script.sh
index 162437af8f22..bd16ce7eb3c8 100755
--- a/contrib/bc/tests/script.sh
+++ b/contrib/bc/tests/script.sh
@@ -2,7 +2,7 @@
#
# SPDX-License-Identifier: BSD-2-Clause
#
-# Copyright (c) 2018-2021 Gavin D. Howard and contributors.
+# Copyright (c) 2018-2023 Gavin D. Howard and contributors.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
@@ -37,49 +37,72 @@ testdir=$(dirname "${script}")
outputdir=${BC_TEST_OUTPUT_DIR:-$testdir}
-# Command-line processing.
-if [ "$#" -lt 2 ]; then
+# Just print the usage and exit with an error. This can receive a message to
+# print.
+# @param 1 A message to print.
+usage() {
+ if [ $# -eq 1 ]; then
+ printf '%s\n\n' "$1"
+ fi
printf 'usage: %s dir script [run_extra_tests] [run_stack_tests] [generate_tests] [time_tests] [exec args...]\n' "$script"
exit 1
+}
+
+# Command-line processing.
+if [ "$#" -lt 2 ]; then
+ usage "Not enough arguments; expect 2 arguments"
fi
d="$1"
shift
+check_d_arg "$d"
+
+scriptdir="$testdir/$d/scripts"
f="$1"
shift
+check_file_arg "$scriptdir/$f"
if [ "$#" -gt 0 ]; then
run_extra_tests="$1"
shift
+ check_bool_arg "$run_extra_tests"
else
run_extra_tests=1
+ check_bool_arg "$run_extra_tests"
fi
if [ "$#" -gt 0 ]; then
run_stack_tests="$1"
shift
+ check_bool_arg "$run_stack_tests"
else
run_stack_tests=1
+ check_bool_arg "$run_stack_tests"
fi
if [ "$#" -gt 0 ]; then
generate="$1"
shift
+ check_bool_arg "$generate"
else
generate=1
+ check_bool_arg "$generate"
fi
if [ "$#" -gt 0 ]; then
time_tests="$1"
shift
+ check_bool_arg "$time_tests"
else
time_tests=0
+ check_bool_arg "$generate"
fi
if [ "$#" -gt 0 ]; then
exe="$1"
shift
+ check_exec_arg "$exe"
else
exe="$testdir/../bin/$d"
fi
@@ -88,20 +111,18 @@ fi
if [ "$d" = "bc" ]; then
if [ "$run_stack_tests" -ne 0 ]; then
- options="-lgq"
+ options="-lgqC"
else
- options="-lq"
+ options="-lqC"
fi
halt="halt"
else
- options="-x"
+ options="-xC"
halt="q"
fi
-scriptdir="$testdir/$d/scripts"
-
name="${f%.*}"
# We specifically want to skip this because it is handled specially.
@@ -111,7 +132,7 @@ fi
# Skip the tests that require extra math if we don't have it.
if [ "$run_extra_tests" -eq 0 ]; then
- if [ "$f" = "rand.bc" ]; then
+ if [ "$f" = "rand.bc" ] || [ "$f" = "root.bc" ] || [ "$f" = "i2rand.bc" ]; then
printf 'Skipping %s script: %s\n' "$d" "$f"
exit 0
fi
@@ -154,11 +175,32 @@ elif [ "$generate" -eq 0 ]; then
printf 'Skipping %s script %s\n' "$d" "$f"
exit 0
else
- # This sed, and the script, are to remove an incompatibility with GNU bc,
- # where GNU bc is wrong. See the development manual
- # (manuals/development.md#script-tests) for more information.
+
+ set +e
+
+ # This is to check that the command exists. If not, we should not try to
+ # generate the test. Instead, we should just skip.
+ command -v "$d" 1>/dev/null 2>&1
+ err="$?"
+
+ set -e
+
+ if [ "$err" -ne 0 ]; then
+ printf 'Could not find %s to generate results; skipping %s script %s\n' "$d" "$d" "$f"
+ exit 0
+ fi
+
printf 'Generating %s results...' "$f"
- printf '%s\n' "$halt" | "$d" "$s" | sed -n -f "$testdir/script.sed" > "$results"
+
+ # This particular test needs to be generated straight.
+ if [ "$d" = "dc" ] && [ "$f" = "stream.dc" ]; then
+ printf '%s\n' "$halt" 2> /dev/null | "$d" "$s" > "$results"
+ else
+ # This sed, and the script, are to remove an incompatibility with GNU
+ # bc, where GNU bc is wrong. See the development manual
+ # (manuals/development.md#script-tests) for more information.
+ printf '%s\n' "$halt" 2> /dev/null | "$d" "$s" | sed -n -f "$testdir/script.sed" > "$results"
+ fi
printf 'done\n'
res="$results"
fi
@@ -170,11 +212,11 @@ printf 'Running %s script %s...' "$d" "$f"
# Yes this is poor timing, but it works.
if [ "$time_tests" -ne 0 ]; then
printf '\n'
- printf '%s\n' "$halt" | /usr/bin/time -p "$exe" "$@" $options "$s" > "$out"
+ printf '%s\n' "$halt" 2> /dev/null | /usr/bin/time -p "$exe" "$@" $options "$s" > "$out"
err="$?"
printf '\n'
else
- printf '%s\n' "$halt" | "$exe" "$@" $options "$s" > "$out"
+ printf '%s\n' "$halt" 2> /dev/null | "$exe" "$@" $options "$s" > "$out"
err="$?"
fi